#ifndef DEBUG_H
#define DEBUG_H

#ifdef IOP_LLA_LIBS_DEBUG
void log_message(int level, const char *fmt, ...);

#define err(...)	log_message(0, __VA_ARGS__)
#define warn(...)	log_message(1, __VA_ARGS__)
#define info(...)	log_message(2, __VA_ARGS__)
#define dbg(...)	log_message(3, __VA_ARGS__)

#else
#define err(...)
#define warn(...)
#define info(...)
#define dbg(...)
#endif

#define WARN_ON(cond) \
({ \
	typeof(cond) __c = (cond); \
	if (__c) warn("%sL%d@%s: [%s] failed\n", __FILE__, __LINE__, __func__, #cond); \
	__c; \
})

#endif /* DEBUG_H */
